/*
Interactions

`Interactions are managed by our flow designer in UI, what you can control via api is how you start and run interaction flow for contact sending events.  Interaction can start in a multiple ways:  - EntryPont - when contact scans QR code ar opens entry point link  - event as trigger - this way you can start flow for single contact  ## Events Events are a data structure related to some contact action. You can use them whenever you want to start active interaction for contact but also inside interaction flow you can define points wher system should wait for custom event sent from your side.   Depending on your use case our predefined interactions might have defined events and instruction what events should be sent.  Events can be sent directly using our REST Api or triggered automatically by our integration modules.  ## Adding attributes to events Adding attributest to event can personalize communication, select branch flow based on attribute value or use them as perameters in other interaction flow actions. Use `body` property in event structure to add key-value attributes. 

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package interactions

import (
	"encoding/json"
)

// checks if the TaskCompletion type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &TaskCompletion{}

// TaskCompletion struct for TaskCompletion
type TaskCompletion struct {
	Id string `json:"id"`
	Status *string `json:"status,omitempty"`
	CampaignSendoutId *string `json:"campaign_sendout_id,omitempty"`
	CreatedAt *string `json:"created_at,omitempty"`
	UpdatedAt *string `json:"updated_at,omitempty"`
	DoneAt *string `json:"done_at,omitempty"`
	DoneBy *string `json:"done_by,omitempty"`
	Deadline *string `json:"deadline,omitempty"`
	NextReminderAt *string `json:"next_reminder_at,omitempty"`
	LastReminderAt *string `json:"last_reminder_at,omitempty"`
	Task *Task `json:"task,omitempty"`
	TaskId *string `json:"task_id,omitempty"`
}

// NewTaskCompletion instantiates a new TaskCompletion object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewTaskCompletion(id string) *TaskCompletion {
	this := TaskCompletion{}
	this.Id = id
	var status string = "open"
	this.Status = &status
	return &this
}

// NewTaskCompletionWithDefaults instantiates a new TaskCompletion object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewTaskCompletionWithDefaults() *TaskCompletion {
	this := TaskCompletion{}
	var status string = "open"
	this.Status = &status
	return &this
}

// GetId returns the Id field value
func (o *TaskCompletion) GetId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Id
}

// GetIdOk returns a tuple with the Id field value
// and a boolean to check if the value has been set.
func (o *TaskCompletion) GetIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Id, true
}

// SetId sets field value
func (o *TaskCompletion) SetId(v string) {
	o.Id = v
}

// GetStatus returns the Status field value if set, zero value otherwise.
func (o *TaskCompletion) GetStatus() string {
	if o == nil || IsNil(o.Status) {
		var ret string
		return ret
	}
	return *o.Status
}

// GetStatusOk returns a tuple with the Status field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *TaskCompletion) GetStatusOk() (*string, bool) {
	if o == nil || IsNil(o.Status) {
		return nil, false
	}
	return o.Status, true
}

// HasStatus returns a boolean if a field has been set.
func (o *TaskCompletion) HasStatus() bool {
	if o != nil && !IsNil(o.Status) {
		return true
	}

	return false
}

// SetStatus gets a reference to the given string and assigns it to the Status field.
func (o *TaskCompletion) SetStatus(v string) {
	o.Status = &v
}

// GetCampaignSendoutId returns the CampaignSendoutId field value if set, zero value otherwise.
func (o *TaskCompletion) GetCampaignSendoutId() string {
	if o == nil || IsNil(o.CampaignSendoutId) {
		var ret string
		return ret
	}
	return *o.CampaignSendoutId
}

// GetCampaignSendoutIdOk returns a tuple with the CampaignSendoutId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *TaskCompletion) GetCampaignSendoutIdOk() (*string, bool) {
	if o == nil || IsNil(o.CampaignSendoutId) {
		return nil, false
	}
	return o.CampaignSendoutId, true
}

// HasCampaignSendoutId returns a boolean if a field has been set.
func (o *TaskCompletion) HasCampaignSendoutId() bool {
	if o != nil && !IsNil(o.CampaignSendoutId) {
		return true
	}

	return false
}

// SetCampaignSendoutId gets a reference to the given string and assigns it to the CampaignSendoutId field.
func (o *TaskCompletion) SetCampaignSendoutId(v string) {
	o.CampaignSendoutId = &v
}

// GetCreatedAt returns the CreatedAt field value if set, zero value otherwise.
func (o *TaskCompletion) GetCreatedAt() string {
	if o == nil || IsNil(o.CreatedAt) {
		var ret string
		return ret
	}
	return *o.CreatedAt
}

// GetCreatedAtOk returns a tuple with the CreatedAt field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *TaskCompletion) GetCreatedAtOk() (*string, bool) {
	if o == nil || IsNil(o.CreatedAt) {
		return nil, false
	}
	return o.CreatedAt, true
}

// HasCreatedAt returns a boolean if a field has been set.
func (o *TaskCompletion) HasCreatedAt() bool {
	if o != nil && !IsNil(o.CreatedAt) {
		return true
	}

	return false
}

// SetCreatedAt gets a reference to the given string and assigns it to the CreatedAt field.
func (o *TaskCompletion) SetCreatedAt(v string) {
	o.CreatedAt = &v
}

// GetUpdatedAt returns the UpdatedAt field value if set, zero value otherwise.
func (o *TaskCompletion) GetUpdatedAt() string {
	if o == nil || IsNil(o.UpdatedAt) {
		var ret string
		return ret
	}
	return *o.UpdatedAt
}

// GetUpdatedAtOk returns a tuple with the UpdatedAt field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *TaskCompletion) GetUpdatedAtOk() (*string, bool) {
	if o == nil || IsNil(o.UpdatedAt) {
		return nil, false
	}
	return o.UpdatedAt, true
}

// HasUpdatedAt returns a boolean if a field has been set.
func (o *TaskCompletion) HasUpdatedAt() bool {
	if o != nil && !IsNil(o.UpdatedAt) {
		return true
	}

	return false
}

// SetUpdatedAt gets a reference to the given string and assigns it to the UpdatedAt field.
func (o *TaskCompletion) SetUpdatedAt(v string) {
	o.UpdatedAt = &v
}

// GetDoneAt returns the DoneAt field value if set, zero value otherwise.
func (o *TaskCompletion) GetDoneAt() string {
	if o == nil || IsNil(o.DoneAt) {
		var ret string
		return ret
	}
	return *o.DoneAt
}

// GetDoneAtOk returns a tuple with the DoneAt field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *TaskCompletion) GetDoneAtOk() (*string, bool) {
	if o == nil || IsNil(o.DoneAt) {
		return nil, false
	}
	return o.DoneAt, true
}

// HasDoneAt returns a boolean if a field has been set.
func (o *TaskCompletion) HasDoneAt() bool {
	if o != nil && !IsNil(o.DoneAt) {
		return true
	}

	return false
}

// SetDoneAt gets a reference to the given string and assigns it to the DoneAt field.
func (o *TaskCompletion) SetDoneAt(v string) {
	o.DoneAt = &v
}

// GetDoneBy returns the DoneBy field value if set, zero value otherwise.
func (o *TaskCompletion) GetDoneBy() string {
	if o == nil || IsNil(o.DoneBy) {
		var ret string
		return ret
	}
	return *o.DoneBy
}

// GetDoneByOk returns a tuple with the DoneBy field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *TaskCompletion) GetDoneByOk() (*string, bool) {
	if o == nil || IsNil(o.DoneBy) {
		return nil, false
	}
	return o.DoneBy, true
}

// HasDoneBy returns a boolean if a field has been set.
func (o *TaskCompletion) HasDoneBy() bool {
	if o != nil && !IsNil(o.DoneBy) {
		return true
	}

	return false
}

// SetDoneBy gets a reference to the given string and assigns it to the DoneBy field.
func (o *TaskCompletion) SetDoneBy(v string) {
	o.DoneBy = &v
}

// GetDeadline returns the Deadline field value if set, zero value otherwise.
func (o *TaskCompletion) GetDeadline() string {
	if o == nil || IsNil(o.Deadline) {
		var ret string
		return ret
	}
	return *o.Deadline
}

// GetDeadlineOk returns a tuple with the Deadline field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *TaskCompletion) GetDeadlineOk() (*string, bool) {
	if o == nil || IsNil(o.Deadline) {
		return nil, false
	}
	return o.Deadline, true
}

// HasDeadline returns a boolean if a field has been set.
func (o *TaskCompletion) HasDeadline() bool {
	if o != nil && !IsNil(o.Deadline) {
		return true
	}

	return false
}

// SetDeadline gets a reference to the given string and assigns it to the Deadline field.
func (o *TaskCompletion) SetDeadline(v string) {
	o.Deadline = &v
}

// GetNextReminderAt returns the NextReminderAt field value if set, zero value otherwise.
func (o *TaskCompletion) GetNextReminderAt() string {
	if o == nil || IsNil(o.NextReminderAt) {
		var ret string
		return ret
	}
	return *o.NextReminderAt
}

// GetNextReminderAtOk returns a tuple with the NextReminderAt field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *TaskCompletion) GetNextReminderAtOk() (*string, bool) {
	if o == nil || IsNil(o.NextReminderAt) {
		return nil, false
	}
	return o.NextReminderAt, true
}

// HasNextReminderAt returns a boolean if a field has been set.
func (o *TaskCompletion) HasNextReminderAt() bool {
	if o != nil && !IsNil(o.NextReminderAt) {
		return true
	}

	return false
}

// SetNextReminderAt gets a reference to the given string and assigns it to the NextReminderAt field.
func (o *TaskCompletion) SetNextReminderAt(v string) {
	o.NextReminderAt = &v
}

// GetLastReminderAt returns the LastReminderAt field value if set, zero value otherwise.
func (o *TaskCompletion) GetLastReminderAt() string {
	if o == nil || IsNil(o.LastReminderAt) {
		var ret string
		return ret
	}
	return *o.LastReminderAt
}

// GetLastReminderAtOk returns a tuple with the LastReminderAt field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *TaskCompletion) GetLastReminderAtOk() (*string, bool) {
	if o == nil || IsNil(o.LastReminderAt) {
		return nil, false
	}
	return o.LastReminderAt, true
}

// HasLastReminderAt returns a boolean if a field has been set.
func (o *TaskCompletion) HasLastReminderAt() bool {
	if o != nil && !IsNil(o.LastReminderAt) {
		return true
	}

	return false
}

// SetLastReminderAt gets a reference to the given string and assigns it to the LastReminderAt field.
func (o *TaskCompletion) SetLastReminderAt(v string) {
	o.LastReminderAt = &v
}

// GetTask returns the Task field value if set, zero value otherwise.
func (o *TaskCompletion) GetTask() Task {
	if o == nil || IsNil(o.Task) {
		var ret Task
		return ret
	}
	return *o.Task
}

// GetTaskOk returns a tuple with the Task field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *TaskCompletion) GetTaskOk() (*Task, bool) {
	if o == nil || IsNil(o.Task) {
		return nil, false
	}
	return o.Task, true
}

// HasTask returns a boolean if a field has been set.
func (o *TaskCompletion) HasTask() bool {
	if o != nil && !IsNil(o.Task) {
		return true
	}

	return false
}

// SetTask gets a reference to the given Task and assigns it to the Task field.
func (o *TaskCompletion) SetTask(v Task) {
	o.Task = &v
}

// GetTaskId returns the TaskId field value if set, zero value otherwise.
func (o *TaskCompletion) GetTaskId() string {
	if o == nil || IsNil(o.TaskId) {
		var ret string
		return ret
	}
	return *o.TaskId
}

// GetTaskIdOk returns a tuple with the TaskId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *TaskCompletion) GetTaskIdOk() (*string, bool) {
	if o == nil || IsNil(o.TaskId) {
		return nil, false
	}
	return o.TaskId, true
}

// HasTaskId returns a boolean if a field has been set.
func (o *TaskCompletion) HasTaskId() bool {
	if o != nil && !IsNil(o.TaskId) {
		return true
	}

	return false
}

// SetTaskId gets a reference to the given string and assigns it to the TaskId field.
func (o *TaskCompletion) SetTaskId(v string) {
	o.TaskId = &v
}

func (o TaskCompletion) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o TaskCompletion) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["id"] = o.Id
	if !IsNil(o.Status) {
		toSerialize["status"] = o.Status
	}
	if !IsNil(o.CampaignSendoutId) {
		toSerialize["campaign_sendout_id"] = o.CampaignSendoutId
	}
	if !IsNil(o.CreatedAt) {
		toSerialize["created_at"] = o.CreatedAt
	}
	if !IsNil(o.UpdatedAt) {
		toSerialize["updated_at"] = o.UpdatedAt
	}
	if !IsNil(o.DoneAt) {
		toSerialize["done_at"] = o.DoneAt
	}
	if !IsNil(o.DoneBy) {
		toSerialize["done_by"] = o.DoneBy
	}
	if !IsNil(o.Deadline) {
		toSerialize["deadline"] = o.Deadline
	}
	if !IsNil(o.NextReminderAt) {
		toSerialize["next_reminder_at"] = o.NextReminderAt
	}
	if !IsNil(o.LastReminderAt) {
		toSerialize["last_reminder_at"] = o.LastReminderAt
	}
	if !IsNil(o.Task) {
		toSerialize["task"] = o.Task
	}
	if !IsNil(o.TaskId) {
		toSerialize["task_id"] = o.TaskId
	}
	return toSerialize, nil
}

type NullableTaskCompletion struct {
	value *TaskCompletion
	isSet bool
}

func (v NullableTaskCompletion) Get() *TaskCompletion {
	return v.value
}

func (v *NullableTaskCompletion) Set(val *TaskCompletion) {
	v.value = val
	v.isSet = true
}

func (v NullableTaskCompletion) IsSet() bool {
	return v.isSet
}

func (v *NullableTaskCompletion) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableTaskCompletion(val *TaskCompletion) *NullableTaskCompletion {
	return &NullableTaskCompletion{value: val, isSet: true}
}

func (v NullableTaskCompletion) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableTaskCompletion) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


